设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1063|回复: 9

[标注] 水平/垂直线坐标标注

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2016-12-26 20:42:59 | 显示全部楼层 |阅读模式
  • 插件名称 : 标线坐标
  • 作  者 : Newer
  • 运行环境 :XDRX API 晓东工具箱 
  • 发布时间 :2016-12-26
  • 命令名称 :XDTB_DimLnCoord
  • 插件介绍 :水平/垂直线坐标标注
  • 备  注 : (点击图片可以放大)
    遮罩边框可以用WIPEOUT命令控制显示
(点击图片可以放大)

晓东温馨提示 1、运行环境为 晓东工具箱XDRX API 的插件,请下载最新版本的 晓东工具箱XDRX API开发环境 一键安装
2、在ACAD中如何加载插件,请看 论坛插件使用方法
3、如果您有要求需要定制插件,请到 编程申请 论坛发帖求助

插件详细内容

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
[sell]
(defun c:XDTB_DimLnCoord ( / an base dir e etxt g h inx key pt scl ss tf txt xdir ydir)  (defun _keyword (key)
    (cond
      ((= key "H")
        (if (setq h (getreal (xdrx_prompt "\n输入字高<" #coords_txtheight
                                          ">:" t
                             )
                    )
            )
          (setq #coords_txtheight h)
        )
      )
      ((= key "G")
        (initget 2)
        (if (setq h (getint (xdrx_prompt "\n输入遮罩边距系数(字高比值)<" #XD_GLOBAL_VAR_LAYOUTOFFSET ">:" t)))
          (setq #XD_GLOBAL_VAR_LAYOUTOFFSET (abs h))
        )
      )
    )
    (_prompt)
  )
  (defun _prompt ()
    (xdrx_prompt "\n当前设置: 字高(" #coords_txtheight ") | 遮罩边距(" #XD_GLOBAL_VAR_LAYOUTOFFSET ")")
  )
  (if (not #coords_txtheight)
    (setq #coords_txtheight 3.0)
  )
  (if (not #XD_GLOBAL_VAR_LAYOUTOFFSET)
    (setq #XD_GLOBAL_VAR_LAYOUTOFFSET 5)
  )

  (xdrx_begin)
  (_prompt)
  (setq tf t)
  (setq scl (* (xd::var:getscaleratio) (xd::var:getratio)))
  (while (and
           tf
           (xdrx_initget "H G")
           (setq e (xdrx_entsel "\n拾取线上一点[字高(H)/遮罩边距(G)]<退出>:" '
                                ((0 . "LINE,LWPOLYLINE"))
                   )
           )
         )
    (setq txt nil dir nil)
    (cond
      ((= (type e) 'STR)
        (_keyword e)
      )
      ((= (type e) 'LIST)
        (setq pt (cadr e)
              e (car e)
              xdir (getvar "ucsxdir")
              ydir (getvar "ucsydir")
        )
        (if (xdrx_object_isa e "AcDbPolyline")
          (progn
            (setq inx (xd::polyline:onsegat e (setq pt
                                                    (xdrx_curve_getclosestpoint e
                                                                                (trans pt 1 0)
                                                    )
                                              )
                      )
            )
            (if (setq g (xdrx_getpropertyvalue e "linesegat" inx))
              (progn
                (mapcar
                  'set
                  '(dir an)
                  (xdge::getpropertyvalue g "direction" "angle")
                )
                (xdge::free g)
              )
              (xdrx_prompt "\n选择了弧线段,请选择直线段,重试.")
            )
          )
          (progn
            (setq dir (cadr (xdrx_entity_getecs e))
                  pt (trans pt 1 0)
                  an (xdrx_getpropertyvalue e "angle")
            )
          )
        )
        (if dir
          (progn
            (cond
              ((xdrx_vector_IsParallel xdir dir)
                (setq p (trans pt 0 1))
                (setq txt (strcat "X=" (if (and (= 0 (cadr p))(>= (car p) 0)) "-" "") (rtos (cadr p) 2 (getvar "luprec"))))
              )
              ((xdrx_vector_IsParallel ydir dir)
                (setq txt (strcat "Y=" (rtos (car (trans pt 0 1)) 2 (getvar "luprec"))))
              )
              (t
                (xdrx_prompt "\n选点所在线与当前坐标系X,Y轴不平行,重试.")
              )
            )
            (if txt
              (progn
                (setq an (xd::geom:angleformat an))
                (setq ss (ssadd))
                (xd::text:init 1)
                (setq etxt (xdrx_text_make pt txt (* scl #coords_txtheight)
                                           an
                           )
                )
                (XD::Text:AdjustAlignMent (entlast) 1 2)
                (ssadd (entlast) ss)
                (setq base (trans (xd::geom:get9pt (entlast) 5) 1 0))
;|
                (xdrx_circle_make base (/ #coords_txtheight 5))
                (ssadd (entlast) ss)
|;
                (xdrx_block_make (strcat "XLineCoord-"
                                         (xdrx_getpropertyvalue
                                                                (entlast)
                                                                "handle"
                                         )
                                 ) ss base t
                )
                (xdrx_insert_appendwipeout (entlast)
                                           (/ (* scl #coords_txtheight) #XD_GLOBAL_VAR_LAYOUTOFFSET) t
                )
                (xdrx_entity_move (entlast) (xdrx_getpropertyvalue
                                                                   (entlast) "position"
                                            ) pt
                )
                (xdrx_block_Text2Attribute (entlast))
                (xdrx_object_regen e)
              )
            )
          )
        )
      )
      (t
        (setq tf nil)
      )
    )
  )
  (xdrx_end)
  (princ)
)

[/sell]
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 8220个

财富等级: 富甲天下

发表于 2016-12-26 23:43:59 | 显示全部楼层
实用的程序感谢分享!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 862个

财富等级: 财运亨通

发表于 2016-12-27 07:07:14 | 显示全部楼层
正需要,支持楼主大人了!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 271个

财富等级: 日进斗金

发表于 2016-12-27 08:25:11 | 显示全部楼层
很适用的插件,谢谢作者!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 3个

财富等级: 恭喜发财

发表于 2016-12-27 09:13:30 | 显示全部楼层
有了这个就很方便了哟。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2016-12-27 10:36:16 | 显示全部楼层
1、没有白送的经验,只有不怕被封ID一直不停灌水的人,才有希望得到更多的经验。——马克思
  2、生活就像灌水,只有不怕被封ID的人,才能到达彼岸。  ——马克思
  3、生命的意义在于灌水,在于回帖,而不是在于看帖,也不是在于看帖不回帖。 ——巴金
  4、一个人的价值,应当看他灌了多少水,而不应当看他在贴吧呆了多长时间。 ——爱因斯坦
  5、人只有献身灌水事业,才能找出那实际上是短暂而有风险的生命的意义。  ——爱因斯坦
  6、人的价值蕴藏在人的灌水才能之中。 ——马克思
  7、万事开头难,灌水也是如此。  ——马克思
  8、在马克思看来,灌水是一种在历史上起推动作用的、**的力量。 ——恩格斯
  9、浪费别人的灌水时间是谋财害命,浪费自己的灌水时间是慢性自杀。 ——列宁
  10、把灌水化为行动,比把行动化为语言简单得多。 ——高尔基
  11、不经不停的灌水,不会有更多的经验。 ——伏尔泰
  12、不要在已灌过水的帖子中逗留着! ——巴斯德
  13、经验=不停的灌水+正确的方法+少谈空话。 ——爱因斯坦
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 6208个

财富等级: 富甲天下

发表于 2017-2-1 00:09:32 | 显示全部楼层
谢谢版主提供这么实用的插件!!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 4751个

财富等级: 富可敌国

发表于 2017-2-17 08:33:31 | 显示全部楼层
确实是难得好帖啊,顶先
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 4751个

财富等级: 富可敌国

发表于 2017-2-23 08:44:54 | 显示全部楼层
这个实用性非常强。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 204个

财富等级: 日进斗金

发表于 2017-10-12 15:03:47 | 显示全部楼层
支持一下楼主
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2021-9-22 00:50 , Processed in 0.676717 second(s), 49 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表